diff --git a/reviewboard/hostingsvcs/tests/test_beanstalk.py b/reviewboard/hostingsvcs/tests/test_beanstalk.py
index cb4b087771fc69c76ee0a7e6942824f9abac09fe..84581292277d29c9c184226ef833a967a942235e 100644
--- a/reviewboard/hostingsvcs/tests/test_beanstalk.py
+++ b/reviewboard/hostingsvcs/tests/test_beanstalk.py
@@ -1,11 +1,14 @@
 """Unit tests for the Beanstalk hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.beanstalk import Beanstalk
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 from reviewboard.scmtools.crypto_utils import (decrypt_password,
                                                encrypt_password)
 
 
-class BeanstalkTests(HostingServiceTestCase):
+class BeanstalkTests(HostingServiceTestCase[Beanstalk]):
     """Unit tests for the Beanstalk hosting service."""
 
     service_name = 'beanstalk'
@@ -20,12 +23,12 @@
         'beanstalk_repo_name': 'myrepo',
     }
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Beanstalk service support capabilities"""
         self.assertFalse(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
 
-    def test_get_repository_fields_for_git(self):
+    def test_get_repository_fields_for_git(self) -> None:
         """Testing Beanstalk.get_repository_fields for Git"""
         self.assertEqual(
             self.get_repository_fields(
@@ -41,7 +44,7 @@
                                 'myrepo.git'),
             })
 
-    def test_get_repository_fields_for_subversion(self):
+    def test_get_repository_fields_for_subversion(self) -> None:
         """Testing Beanstalk.get_repository_fields for Subversion"""
         self.assertEqual(
             self.get_repository_fields(
@@ -55,7 +58,7 @@
                 'path': 'https://mydomain.svn.beanstalkapp.com/myrepo/',
             })
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing Beanstalk.authorize"""
         account = self.create_hosting_account(data={})
         service = account.service
@@ -69,7 +72,7 @@
         self.assertEqual(decrypt_password(account.data['password']), 'abc123')
         self.assertTrue(service.is_authorized())
 
-    def test_check_repository(self):
+    def test_check_repository(self) -> None:
         """Testing Beanstalk.check_repository"""
         with self.setup_http_test(payload=b'{}',
                                   expected_http_calls=1) as ctx:
@@ -81,7 +84,7 @@
             url=('https://mydomain.beanstalkapp.com/api/repositories/'
                  'myrepo.json'))
 
-    def test_get_file_with_svn_and_base_commit_id(self):
+    def test_get_file_with_svn_and_base_commit_id(self) -> None:
         """Testing Beanstalk.get_file with Subversion and base commit ID"""
         self._test_get_file(
             tool_name='Subversion',
@@ -89,7 +92,7 @@
             base_commit_id='456',
             expected_revision='123')
 
-    def test_get_file_with_svn_and_revision(self):
+    def test_get_file_with_svn_and_revision(self) -> None:
         """Testing Beanstalk.get_file with Subversion and revision"""
         self._test_get_file(
             tool_name='Subversion',
@@ -97,7 +100,7 @@
             base_commit_id=None,
             expected_revision='123')
 
-    def test_get_file_with_git_and_base_commit_id(self):
+    def test_get_file_with_git_and_base_commit_id(self) -> None:
         """Testing Beanstalk.get_file with Git and base commit ID"""
         self._test_get_file(
             tool_name='Git',
@@ -105,7 +108,7 @@
             base_commit_id='456',
             expected_revision='123')
 
-    def test_get_file_with_git_and_revision(self):
+    def test_get_file_with_git_and_revision(self) -> None:
         """Testing Beanstalk.get_file with Git and revision"""
         self._test_get_file(
             tool_name='Git',
@@ -113,7 +116,7 @@
             base_commit_id=None,
             expected_revision='123')
 
-    def test_get_file_with_svn_and_keywords_collapsed(self):
+    def test_get_file_with_svn_and_keywords_collapsed(self) -> None:
         """Testing Beanstalk.get_file with Subversion and keywords in file
         collapsed
         """
@@ -134,7 +137,7 @@
                 b'$Revision::       $\n'
             ))
 
-    def test_get_file_exists_with_svn_and_base_commit_id(self):
+    def test_get_file_exists_with_svn_and_base_commit_id(self) -> None:
         """Testing Beanstalk.get_file_exists with Subversion and base commit ID
         """
         self._test_get_file_exists(
@@ -144,7 +147,7 @@
             expected_revision='123',
             expected_found=True)
 
-    def test_get_file_exists_with_svn_and_revision(self):
+    def test_get_file_exists_with_svn_and_revision(self) -> None:
         """Testing Beanstalk.get_file_exists with Subversion and revision"""
         self._test_get_file_exists(
             tool_name='Subversion',
@@ -153,7 +156,7 @@
             expected_revision='123',
             expected_found=True)
 
-    def test_get_file_exists_with_git_and_base_commit_id(self):
+    def test_get_file_exists_with_git_and_base_commit_id(self) -> None:
         """Testing Beanstalk.get_file_exists with Git and base commit ID"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -162,7 +165,7 @@
             expected_revision='456',
             expected_found=True)
 
-    def test_get_file_exists_with_git_and_revision(self):
+    def test_get_file_exists_with_git_and_revision(self) -> None:
         """Testing Beanstalk.get_file_exists with Git and revision"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -171,7 +174,7 @@
             expected_revision='123',
             expected_found=True)
 
-    def test_normalize_patch_with_svn_and_expanded_keywords(self):
+    def test_normalize_patch_with_svn_and_expanded_keywords(self) -> None:
         """Testing Beanstalk.normalize_patch with Subversion and expanded
         keywords
         """
@@ -225,7 +228,7 @@
 
         self.assertTrue(repository.hosting_service.normalize_patch.called)
 
-    def test_normalize_patch_with_svn_and_no_expanded_keywords(self):
+    def test_normalize_patch_with_svn_and_no_expanded_keywords(self) -> None:
         """Testing Beanstalk.normalize_patch with Subversion and no expanded
         keywords
         """
@@ -279,24 +282,39 @@
 
         self.assertTrue(repository.hosting_service.normalize_patch.called)
 
-    def _test_get_file(self, tool_name, revision, base_commit_id,
-                       expected_revision, file_contents=b'My data',
-                       expected_file_contents=b'My data',
-                       expected_fetch_keywords=False):
+    def _test_get_file(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+        file_contents: bytes = b'My data',
+        expected_file_contents: bytes = b'My data',
+        expected_fetch_keywords: bool = False,
+    ) -> None:
         """Test file fetching.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
-            revision (unicode, optional):
+            revision (str):
                 The revision to check.
 
-            base_commit_id (unicode, optional):
+            base_commit_id (str):
                 The base commit to fetch against.
 
-            expected_revision (unicode, optional):
+            expected_revision (str):
                 The revision expected in the payload.
+
+            file_contents (bytes, optional):
+                The file contents to return.
+
+            expected_file_contents (bytes, optional):
+                The expected result for the file contents.
+
+            expected_fetch_keywords (bool, optional):
+                Whether to expect keywords to be fetched.
         """
         url_prefix = 'https://mydomain.beanstalkapp.com'
 
@@ -351,24 +369,30 @@
         if expected_fetch_keywords:
             ctx.assertHTTPCall(1, url='%s%s' % (url_prefix, svn_props_url))
 
-    def _test_get_file_exists(self, tool_name, revision, base_commit_id,
-                              expected_revision, expected_found):
+    def _test_get_file_exists(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+        expected_found: bool,
+    ) -> None:
         """Test file existence checks.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
-            revision (unicode, optional):
+            revision (str, optional):
                 The revision to check.
 
-            base_commit_id (unicode, optional):
+            base_commit_id (str):
                 The base commit to fetch against.
 
-            expected_revision (unicode, optional):
+            expected_revision (str):
                 The revision expected in the payload.
 
-            expected_found (bool, optional):
+            expected_found (bool):
                 Whether a truthy response should be expected.
         """
         if expected_found:
diff --git a/reviewboard/hostingsvcs/tests/test_bitbucket.py b/reviewboard/hostingsvcs/tests/test_bitbucket.py
index 954539995be6aaaee9802624a59b95d4effc169b..10f1307b370ca6a8dcfdac37315937d4c5e40d43 100644
--- a/reviewboard/hostingsvcs/tests/test_bitbucket.py
+++ b/reviewboard/hostingsvcs/tests/test_bitbucket.py
@@ -1,13 +1,16 @@
 """Unit tests for the Bitbucket hosting service."""
 
+from __future__ import annotations
+
 import json
+from typing import TYPE_CHECKING
 
 from django.contrib.auth.models import User
 from django.test.client import RequestFactory
 from django.utils.safestring import SafeText
 from djblets.testing.decorators import add_fixtures
 
-from reviewboard.hostingsvcs.bitbucket import BitbucketAuthForm
+from reviewboard.hostingsvcs.bitbucket import Bitbucket, BitbucketAuthForm
 from reviewboard.hostingsvcs.errors import (AuthorizationError,
                                             RepositoryError)
 from reviewboard.hostingsvcs.hook_utils import logger
@@ -20,8 +23,11 @@
 from reviewboard.site.models import LocalSite
 from reviewboard.site.urlresolvers import local_site_reverse
 
-
-class BitbucketTestCase(HostingServiceTestCase):
+if TYPE_CHECKING:
+    from django.test.client import _MonkeyPatchedWSGIResponse
+
+
+class BitbucketTestCase(HostingServiceTestCase[Bitbucket]):
     """Base class for Bitbucket test suites."""
 
     service_name = 'bitbucket'
@@ -39,12 +45,12 @@
 class BitbucketTests(BitbucketTestCase):
     """Unit tests for the Bitbucket hosting service."""
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Bitbucket service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
 
-    def test_get_repository_fields_with_git_and_personal_plan(self):
+    def test_get_repository_fields_with_git_and_personal_plan(self) -> None:
         """Testing Bitbucket.get_repository_fields for Git and plan=personal"""
         self.assertEqual(
             self.get_repository_fields(
@@ -60,7 +66,7 @@
                                 'myrepo.git'),
             })
 
-    def test_get_repository_fields_with_git_and_team_plan(self):
+    def test_get_repository_fields_with_git_and_team_plan(self) -> None:
         """Testing Bitbucket.get_repository_fields for Git and plan=team"""
         self.assertEqual(
             self.get_repository_fields(
@@ -77,7 +83,7 @@
                                 'myrepo.git'),
             })
 
-    def test_get_repository_fields_with_git_and_other_user_plan(self):
+    def test_get_repository_fields_with_git_and_other_user_plan(self) -> None:
         """Testing Bitbucket.get_repository_fields for Git and plan=other-user
         """
         self.assertEqual(
@@ -95,7 +101,7 @@
                                 'myrepo.git'),
             })
 
-    def test_get_bug_tracker_field_with_personal_plan(self):
+    def test_get_bug_tracker_field_with_personal_plan(self) -> None:
         """Testing Bitbucket.get_bug_tracker_field with plan=personal"""
         self.assertTrue(self.service_class.get_bug_tracker_requires_username(
             plan='personal'))
@@ -108,7 +114,7 @@
                 }),
             'https://bitbucket.org/myuser/myrepo/issue/%s/')
 
-    def test_get_bug_tracker_field_with_team_plan(self):
+    def test_get_bug_tracker_field_with_team_plan(self) -> None:
         """Testing Bitbucket.get_bug_tracker_field with plan=team"""
         self.assertFalse(self.service_class.get_bug_tracker_requires_username(
             plan='team'))
@@ -121,7 +127,7 @@
                 }),
             'https://bitbucket.org/myteam/myrepo/issue/%s/')
 
-    def test_get_bug_tracker_field_with_other_user_plan(self):
+    def test_get_bug_tracker_field_with_other_user_plan(self) -> None:
         """Testing Bitbucket.get_bug_tracker_field with plan=other-user"""
         self.assertFalse(self.service_class.get_bug_tracker_requires_username(
             plan='other-user'))
@@ -134,7 +140,7 @@
                 }),
             'https://bitbucket.org/someuser/myrepo/issue/%s/')
 
-    def test_get_repository_hook_instructions(self):
+    def test_get_repository_hook_instructions(self) -> None:
         """Testing BitBucket.get_repository_hook_instructions"""
         account = self.create_hosting_account()
         repository = self.create_repository(hosting_account=account)
@@ -159,7 +165,7 @@
         self.assertIn('Review Board supports closing', content)
         self.assertIn('<code>Review Board</code>', content)
 
-    def test_check_repository_with_personal_plan(self):
+    def test_check_repository_with_personal_plan(self) -> None:
         """Testing Bitbucket.check_repository with plan=personal"""
         with self.setup_http_test(payload=b'{"scm": "git"}',
                                   expected_http_calls=1) as ctx:
@@ -172,7 +178,7 @@
             url=('https://bitbucket.org/api/2.0/repositories/myuser/myrepo'
                  '?fields=scm'))
 
-    def test_check_repository_with_team_plan(self):
+    def test_check_repository_with_team_plan(self) -> None:
         """Testing Bitbucket.check_repository with plan=team"""
         with self.setup_http_test(payload=b'{"scm": "git"}',
                                   expected_http_calls=1) as ctx:
@@ -186,7 +192,7 @@
             url=('https://bitbucket.org/api/2.0/repositories/myteam/myrepo'
                  '?fields=scm'))
 
-    def test_check_repository_with_other_user_plan(self):
+    def test_check_repository_with_other_user_plan(self) -> None:
         """Testing Bitbucket.check_repository with plan=other-user"""
         with self.setup_http_test(payload=b'{"scm": "git"}',
                                   expected_http_calls=1) as ctx:
@@ -201,7 +207,7 @@
             url=('https://bitbucket.org/api/2.0/repositories/someuser/myrepo'
                  '?fields=scm'))
 
-    def test_check_repository_with_slash(self):
+    def test_check_repository_with_slash(self) -> None:
         """Testing Bitbucket.check_repository with /"""
         expected_message = \
             'Please specify just the name of the repository, not a path.'
@@ -213,7 +219,7 @@
                     bitbucket_team_repo_name='myteam/myrepo',
                     plan='team')
 
-    def test_check_repository_with_dot_git(self):
+    def test_check_repository_with_dot_git(self) -> None:
         """Testing Bitbucket.check_repository with .git"""
         expected_message = \
             'Please specify just the name of the repository without ".git".'
@@ -225,7 +231,7 @@
                     bitbucket_team_repo_name='myrepo.git',
                     plan='team')
 
-    def test_check_repository_with_type_mismatch(self):
+    def test_check_repository_with_type_mismatch(self) -> None:
         """Testing Bitbucket.check_repository with type mismatch"""
         error_message = (
             'The Bitbucket repository being configured does not match the '
@@ -247,7 +253,7 @@
             url=('https://bitbucket.org/api/2.0/repositories/myteam/myrepo'
                  '?fields=scm'))
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing Bitbucket.authorize"""
         hosting_account = self.create_hosting_account(data={})
 
@@ -270,7 +276,7 @@
             username='myuser',
             password='abc123')
 
-    def test_authorize_with_bad_credentials(self):
+    def test_authorize_with_bad_credentials(self) -> None:
         """Testing Bitbucket.authorize with bad credentials"""
         hosting_account = self.create_hosting_account(data={})
         expected_message = (
@@ -298,7 +304,7 @@
             username='myuser',
             password='abc123')
 
-    def test_get_file_with_git_and_base_commit_id(self):
+    def test_get_file_with_git_and_base_commit_id(self) -> None:
         """Testing Bitbucket.get_file with Git and base commit ID"""
         self._test_get_file(
             tool_name='Git',
@@ -306,7 +312,7 @@
             base_commit_id='456',
             expected_revision='456')
 
-    def test_get_file_with_git_and_revision(self):
+    def test_get_file_with_git_and_revision(self) -> None:
         """Testing Bitbucket.get_file with Git and revision"""
         with self.assertRaises(FileNotFoundError):
             self._test_get_file(tool_name='Git',
@@ -314,7 +320,7 @@
                                 base_commit_id=None,
                                 expected_revision='123')
 
-    def test_get_file_exists_with_git_and_base_commit_id(self):
+    def test_get_file_exists_with_git_and_base_commit_id(self) -> None:
         """Testing Bitbucket.get_file_exists with Git and base commit ID"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -323,7 +329,7 @@
             expected_revision='456',
             expected_found=True)
 
-    def test_get_file_exists_with_git_and_revision(self):
+    def test_get_file_exists_with_git_and_revision(self) -> None:
         """Testing Bitbucket.get_file_exists with Git and revision"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -333,7 +339,7 @@
             expected_found=False,
             expected_http_called=False)
 
-    def test_get_file_exists_with_git_and_404(self):
+    def test_get_file_exists_with_git_and_404(self) -> None:
         """Testing BitBucket.get_file_exists with Git and a 404 error"""
         self._test_get_file_exists(
             tool_name='Git',
@@ -342,7 +348,7 @@
             expected_revision='456',
             expected_found=False)
 
-    def test_get_branches(self):
+    def test_get_branches(self) -> None:
         """Testing Bitbucket.get_branches"""
         branches_api_response_1 = self.dump_json({
             'next': ('https://bitbucket.org/api/2.0/repositories/myuser/'
@@ -441,7 +447,7 @@
                        commit='d286691517e6325fea5c7a21d5e44568f7d33647'),
             ])
 
-    def test_get_commits(self):
+    def test_get_commits(self) -> None:
         """Testing Bitbucket.get_commits"""
         payload = self.dump_json({
             'size': 2,
@@ -506,7 +512,7 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_commits_with_start(self):
+    def test_get_commits_with_start(self) -> None:
         """Testing Bitbucket.get_commits with start="""
         payload = self.dump_json({
             'size': 2,
@@ -573,7 +579,7 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_commits_with_branch(self):
+    def test_get_commits_with_branch(self) -> None:
         """Testing Bitbucket.get_commits with branch="""
         payload = self.dump_json({
             'size': 2,
@@ -639,7 +645,7 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_commits_with_start_and_branch(self):
+    def test_get_commits_with_start_and_branch(self) -> None:
         """Testing Bitbucket.get_commits with start= and branch="""
         payload = self.dump_json({
             'size': 2,
@@ -707,7 +713,7 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_change(self):
+    def test_get_change(self) -> None:
         """Testing BitBucket.get_change"""
         commit_sha = '1c44b461cebe5874a857c51a4a13a849a4d1e52d'
         parent_sha = '44568f7d33647d286691517e6325fea5c7a21d5e'
@@ -754,21 +760,26 @@
                    parent=parent_sha))
         self.assertEqual(commit.diff, b'This is a test \xc7.\n')
 
-    def _test_get_file(self, tool_name, revision, base_commit_id,
-                       expected_revision):
+    def _test_get_file(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+    ) -> None:
         """Test file fetching.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
-            revision (unicode, optional):
+            revision (str):
                 The revision to check.
 
-            base_commit_id (unicode, optional):
+            base_commit_id (str):
                 The base commit to fetch against.
 
-            expected_revision (unicode, optional):
+            expected_revision (str):
                 The revision expected in the payload.
         """
         with self.setup_http_test(payload=b'My data',
@@ -788,25 +799,31 @@
         self.assertIsInstance(result, bytes)
         self.assertEqual(result, b'My data')
 
-    def _test_get_file_exists(self, tool_name, revision, base_commit_id,
-                              expected_revision, expected_found,
-                              expected_http_called=True):
+    def _test_get_file_exists(
+        self,
+        tool_name: str,
+        revision: str,
+        base_commit_id: str,
+        expected_revision: str,
+        expected_found: bool,
+        expected_http_called: bool = True,
+    ) -> None:
         """Test file existence checks.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
-            revision (unicode, optional):
+            revision (str):
                 The revision to check.
 
-            base_commit_id (unicode, optional):
+            base_commit_id (str):
                 The base commit to fetch against.
 
-            expected_revision (unicode, optional):
+            expected_revision (str):
                 The revision expected in the payload.
 
-            expected_found (bool, optional):
+            expected_found (bool):
                 Whether a truthy response should be expected.
 
             expected_http_called (bool, optional):
@@ -847,7 +864,7 @@
 class BitbucketAuthFormTests(BitbucketTestCase):
     """Unit tests for BitbucketAuthForm."""
 
-    def test_clean_hosting_account_username_with_username(self):
+    def test_clean_hosting_account_username_with_username(self) -> None:
         """Testing BitbucketAuthForm.clean_hosting_account_username with
         username
         """
@@ -860,7 +877,7 @@
 
         self.assertTrue(form.is_valid())
 
-    def test_clean_hosting_account_username_with_email(self):
+    def test_clean_hosting_account_username_with_email(self) -> None:
         """Testing BitbucketAuthForm.clean_hosting_account_username with
         e-mail address
         """
@@ -886,17 +903,17 @@
     COMMITS_URL = ('/api/2.0/repositories/test/test/commits'
                    '?exclude=abc123&include=def123')
 
-    def test_close_submitted_hook(self):
+    def test_close_submitted_hook(self) -> None:
         """Testing BitBucket close_submitted hook"""
         self._test_post_commit_hook()
 
     @add_fixtures(['test_site'])
-    def test_close_submitted_hook_with_local_site(self):
+    def test_close_submitted_hook_with_local_site(self) -> None:
         """Testing BitBucket close_submitted hook with a Local Site"""
         self._test_post_commit_hook(
             LocalSite.objects.get(name=self.local_site_name))
 
-    def test_close_submitted_hook_with_truncated_commits(self):
+    def test_close_submitted_hook_with_truncated_commits(self) -> None:
         """Testing BitBucket close_submitted hook with truncated list of
         commits
         """
@@ -988,7 +1005,7 @@
         changedesc = review_request2.changedescs.get()
         self.assertEqual(changedesc.text, 'Pushed to master (9fad897)')
 
-    def test_close_submitted_hook_with_truncated_commits_limits(self):
+    def test_close_submitted_hook_with_truncated_commits_limits(self) -> None:
         """Testing BitBucket close_submitted hook with truncated list of
         commits obeys limits
         """
@@ -1060,7 +1077,7 @@
                          review_request1.PENDING_REVIEW)
         self.assertEqual(review_request2.changedescs.count(), 0)
 
-    def test_close_submitted_hook_with_truncated_and_auth_error(self):
+    def test_close_submitted_hook_with_truncated_and_auth_error(self) -> None:
         """Testing BitBucket close_submitted hook with truncated list of
         commits and authentication error talking to Bitbucket
         """
@@ -1118,7 +1135,7 @@
                          review_request1.PENDING_REVIEW)
         self.assertEqual(review_request2.changedescs.count(), 0)
 
-    def test_close_submitted_hook_with_too_many_login_failures(self):
+    def test_close_submitted_hook_with_too_many_login_failures(self) -> None:
         """Testing BitBucket close_submitted hook with truncated list of
         commits and too many login failures talking to Bitbucket
         """
@@ -1184,7 +1201,7 @@
                          review_request1.PENDING_REVIEW)
         self.assertEqual(review_request2.changedescs.count(), 0)
 
-    def test_close_submitted_hook_with_invalid_repo(self):
+    def test_close_submitted_hook_with_invalid_repo(self) -> None:
         """Testing BitBucket close_submitted hook with invalid repository"""
         repository = self.create_repository()
 
@@ -1212,7 +1229,7 @@
         self.assertEqual(review_request.changedescs.count(), 0)
 
     @add_fixtures(['test_site'])
-    def test_close_submitted_hook_with_invalid_site(self):
+    def test_close_submitted_hook_with_invalid_site(self) -> None:
         """Testing BitBucket close_submitted hook with invalid Local Site"""
         local_site = LocalSite.objects.get(name=self.local_site_name)
         account = self.create_hosting_account(local_site=local_site)
@@ -1245,7 +1262,7 @@
         self.assertEqual(review_request.status, review_request.PENDING_REVIEW)
         self.assertEqual(review_request.changedescs.count(), 0)
 
-    def test_close_submitted_hook_with_invalid_service_id(self):
+    def test_close_submitted_hook_with_invalid_service_id(self) -> None:
         """Testing BitBucket close_submitted hook with invalid hosting
         service ID
         """
@@ -1279,7 +1296,7 @@
         self.assertEqual(review_request.status, review_request.PENDING_REVIEW)
         self.assertEqual(review_request.changedescs.count(), 0)
 
-    def test_close_submitted_hook_with_invalid_review_request(self):
+    def test_close_submitted_hook_with_invalid_review_request(self) -> None:
         """Testing BitBucket close_submitted hook with invalid review request
         """
         self.spy_on(logger.error)
@@ -1314,7 +1331,10 @@
             'close_all_review_requests: Review request #%s does not exist.',
             9999))
 
-    def _test_post_commit_hook(self, local_site=None):
+    def _test_post_commit_hook(
+        self,
+        local_site: (LocalSite | None) = None,
+    ) -> None:
         """Testing posting to a commit hook.
 
         This will simulate pushing a commit and posting the resulting webhook
@@ -1355,15 +1375,19 @@
         changedesc = review_request.changedescs.get()
         self.assertEqual(changedesc.text, 'Pushed to master (1c44b46)')
 
-    def _post_commit_hook_payload(self, post_url, review_request_url,
-                                  truncated=False):
+    def _post_commit_hook_payload(
+        self,
+        post_url: str,
+        review_request_url: str,
+        truncated: bool = False,
+    ) -> _MonkeyPatchedWSGIResponse:
         """Post a payload for a hook for testing.
 
         Args:
-            post_url (unicode):
+            post_url (str):
                 The URL to post to.
 
-            review_request_url (unicode):
+            review_request_url (str):
                 The URL of the review request being represented in the
                 payload.
 
diff --git a/reviewboard/hostingsvcs/tests/test_bugzilla.py b/reviewboard/hostingsvcs/tests/test_bugzilla.py
index 0266910da5c112e38bd2b54edb4b535542dd8c01..afc63c46a54b2f3eae75495914dc2b496d144586 100644
--- a/reviewboard/hostingsvcs/tests/test_bugzilla.py
+++ b/reviewboard/hostingsvcs/tests/test_bugzilla.py
@@ -1,20 +1,23 @@
 """Unit tests for the Bugzilla hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.bugzilla import Bugzilla
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 
 
-class BugzillaTests(HostingServiceTestCase):
+class BugzillaTests(HostingServiceTestCase[Bugzilla]):
     """Unit tests for the Bugzilla hosting service."""
 
     service_name = 'bugzilla'
     fixtures = ['test_scmtools']
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Bugzilla service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_repositories)
 
-    def test_bug_tracker_field(self):
+    def test_bug_tracker_field(self) -> None:
         """Testing Bugzilla.get_bug_tracker_field"""
         self.assertFalse(
             self.service_class.get_bug_tracker_requires_username())
